package sca.component.java.impl;

import java.io.File;

import com.ibm.j2ca.base.AdapterBOUtil;
import com.ibm.j2ca.base.exceptions.BusinessObjectDefinitionNotFoundException;
import com.ibm.j2ca.base.exceptions.InvalidObjectDefinitionException;
import com.ibm.websphere.sca.Service;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.Ticket;
import commonj.sdo.DataObject;

public class Component1Impl {
	/**
	 * Default constructor.
	 */
	public Component1Impl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}
	
	private void outBoundCall(byte[] inputBytes, String fileName)
	throws BusinessObjectDefinitionNotFoundException,
			InvalidObjectDefinitionException {
			String BGNameSpace = "http://www.ibm.com/xmlns/prod/websphere/j2ca/flatfile/flatfilebg";
			String directoryPath = "C:\\flatfile\\outputdir";
			//fileName = "assemble.out";
			DataObject dataGraphObj = AdapterBOUtil.createBusinessObject(
					BGNameSpace, "FlatFileBG");
			DataObject dataGraph = dataGraphObj.getContainer();
			dataGraph.createDataObject("FlatFile");
			dataGraphObj = dataGraph;
			DataObject retrieveWrapperDataObject = dataGraphObj
					.getDataObject("FlatFile");
			DataObject unstructuredContent = AdapterBOUtil
					.createBusinessObject(
							"http://www.ibm.com/xmlns/prod/websphere/j2ca/base/unstructuredcontent",
							"UnstructuredContent");
			unstructuredContent.setBytes("AsBinary", inputBytes);
			
			retrieveWrapperDataObject.setDataObject("content", unstructuredContent);
			retrieveWrapperDataObject.set("fileName", fileName);
			retrieveWrapperDataObject.set("directoryPath", directoryPath);
			
			
			File fileobj = new File(directoryPath+"\\"+fileName);
			System.out.println(" Does file exist?  = " + fileobj.exists());

			synchronized(this){
				Service jService = (Service) ServiceManager.INSTANCE.locateService("FlatFileOutboundInterfacePartner");
				if(!fileobj.exists()){
					DataObject result = (DataObject) jService.invoke("createFlatFile", dataGraphObj);
				}
				else{
					DataObject result = (DataObject) jService.invoke("appendFlatFile", dataGraphObj);
				}
			}
	}

	/**
	 * This method is used to locate the service for the reference
	 * named "FlatFileOutboundInterfacePartner".  This will return an instance of 
	 * {@link com.ibm.websphere.sca.Service}.  This is the dynamic
	 * interface which is used to invoke operations on the reference service
	 * either synchronously or asynchronously.  You will need to pass the operation
	 * name in order to invoke an operation on the service.
	 *
	 * @generated (com.ibm.wbit.java)
	 *
	 * @return Service
	 */
	public Service locateService_FlatFileOutboundInterfacePartner() {
		return (Service) ServiceManager.INSTANCE
				.locateService("FlatFileOutboundInterfacePartner");
	}

	/**
	 * Method generated to support implemention of operation "emitFlatFile" defined for WSDL port type 
	 * named "interface.FlatFileInboundInterface".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 * @throws InvalidObjectDefinitionException
	 * @throws BusinessObjectDefinitionNotFoundException
	 */
	public void emitFlatFile(DataObject emitFlatFileInput) throws BusinessObjectDefinitionNotFoundException, InvalidObjectDefinitionException {
		//TODO Needs to be implemented.
		String fName = "C:\\FlatFile\\outputdir\\assemble.out";
		DataObject flatFile = emitFlatFileInput.getDataObject("FlatFile");
		String directoryPath = flatFile.getString("directoryPath");
		System.out.println("1111 Directory Path = " + directoryPath);
		String fileName = flatFile.getString("fileName");
		System.out.println("2222 File Name = " + fileName);
		String chunkFileName = flatFile.getString("chunkFileName");
		System.out.println("3333 Chunk File Name = " + chunkFileName);
		DataObject unstructuredContent = flatFile.getDataObject("content");
		byte[] inputBytes = unstructuredContent.getBytes("AsBinary");
		System.out.println("4444 Unstructured Content = " + inputBytes);

		if (inputBytes != null) {
			System.out.println("Inputbytes are = "+ new String(inputBytes));
		}
		outBoundCall(inputBytes, fileName);
	}

	/**
	 * Method generated to support the async implementation using callback
	 * for the operation "interface.FlatFileOutboundInterface#retrieveFlatFile(DataObject retrieveFlatFileInput)"
	 * of wsdl interface "interface.FlatFileOutboundInterface"	
	 */
	public void onRetrieveFlatFileResponse(Ticket __ticket,
			DataObject returnValue, Exception exception) {
		//TODO Needs to be implemented.
	}

	/**
	 * Method generated to support the async implementation using callback
	 * for the operation "interface.FlatFileOutboundInterface#listFlatFile(DataObject listFlatFileInput)"
	 * of wsdl interface "interface.FlatFileOutboundInterface"	
	 */
	public void onListFlatFileResponse(Ticket __ticket, DataObject returnValue,
			Exception exception) {
		//TODO Needs to be implemented.
	}

	/**
	 * Method generated to support the async implementation using callback
	 * for the operation "interface.FlatFileOutboundInterface#existsFlatFile(DataObject existsFlatFileInput)"
	 * of wsdl interface "interface.FlatFileOutboundInterface"	
	 */
	public void onExistsFlatFileResponse(Ticket __ticket,
			DataObject returnValue, Exception exception) {
		//TODO Needs to be implemented.
	}

}